package hello;

/**
 * A simple Java test for HelloCustomer.xls
 * 
 * @author jf 
 */
 
import com.openrules.ruleengine.OpenRulesEngine;

public class RunHelloCustomer {

	public static void main(String[] args)
	{
		String fileName = "file:rules/main/HelloCustomer.xls";
		String methodName = "helloCustomer";
		if (args.length > 1)
		{
			fileName = args[0];
			methodName = args[1];
		}
		OpenRulesEngine engine = new OpenRulesEngine(fileName);
		System.out.println( 
		"\n=====================================================\n" +
		   "OpenRulesEngine: " + fileName + 
		"\n=====================================================\n");
		Customer customer = new Customer();
		customer.setName("Robinson");
		customer.setGender("Female");
		customer.setMaritalStatus("Married");
		
		Response response = new Response();
		Object[] objects = new Object[] { customer, response };
		engine.run(methodName,objects);
		System.out.println("From Java : " + 
		 		 response.getMap().get("greeting") + ", " +
				 response.getMap().get("salutation") + 
				 customer.getName() + "!"		 					
		 		);
	}
}
