/*
 * Created on Jun 18, 2005
 * OpenRules, Inc.
 */
package hello;

/**
 * @author jacob  
 */

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

import javax.rules.RuleRuntime;
import javax.rules.RuleServiceProvider;
import javax.rules.RuleServiceProviderManager;
import javax.rules.StatelessRuleSession;
import javax.rules.admin.RuleAdministrator;
import javax.rules.admin.RuleExecutionSet;
import javax.rules.admin.RuleExecutionSetProvider;

import com.openrules.ruleengine.OpenRulesEngine;

public class GreetingEngine {
	
	private StatelessRuleSession statelessRuleSession;

	public GreetingEngine() {
		
	  try {	
		
	  	String fileName = "HelloCustomer.xls";  
		String methodName = "helloCustomer";
		// register RuleServiceProvider
		String ruleServiceProviderUri = "com.openrules.jsr94.rules.RuleServiceProviderImpl";
		Class RuleServiceProviderClass = com.openrules.jsr94.rules.RuleServiceProviderImpl.class;
		RuleServiceProviderManager.registerRuleServiceProvider(
				ruleServiceProviderUri, RuleServiceProviderClass);

		// get RuleServiceProvider from RuleServiceProviderManager
		RuleServiceProvider ruleServiceProvider = RuleServiceProviderManager
				.getRuleServiceProvider(ruleServiceProviderUri);

		// get RuleAdministrator from RuleServiceProvider
		RuleAdministrator ruleAdministrator = ruleServiceProvider
				.getRuleAdministrator();

		// get RuleExecutionSetProvider from RuleAdministrator
		System.out.println("getRuleExecutionSetProvider");
		Map ruleExecutionSetProviderProperties = new HashMap();
		RuleExecutionSetProvider ruleSetProvider = ruleAdministrator
				.getRuleExecutionSetProvider(ruleExecutionSetProviderProperties);

		// create RuleExecutionSet from ruleExecutionSetFileUri
		String ruleExecutionSetFileUri = fileName;
		Map ruleExecutionSetCreationProperties = new HashMap();
		ruleExecutionSetCreationProperties.put("main", methodName);
		// define rule engine
		OpenRulesEngine engine = new OpenRulesEngine(fileName,getClass());
		engine.setMethod("helloCustomer");
		ruleExecutionSetCreationProperties.put("RuleEngine",engine);
	
		RuleExecutionSet ruleExecutionSet = ruleSetProvider
				.createRuleExecutionSet(ruleExecutionSetFileUri,
						ruleExecutionSetCreationProperties);
		
		// register/bind the RuleExecutionSet as ruleExecutionSetBindUri
		String ruleExecutionSetBindUri = methodName;
		Map ruleExecutionSetRegistrationProperties = new HashMap();
		ruleAdministrator.registerRuleExecutionSet(ruleExecutionSetBindUri,
				ruleExecutionSet, ruleExecutionSetRegistrationProperties);

		// get RuleRuntime from RuleServiceProvider
		RuleRuntime ruleRuntime = ruleServiceProvider.getRuleRuntime();

		// create StatelessRuleSession in RuleRuntime
		System.out.println("create StatelessRuleSession in RuleRuntime");
		Map ruleSessionProperties = new HashMap();
		statelessRuleSession = (StatelessRuleSession) ruleRuntime
				.createRuleSession(ruleExecutionSetBindUri,
						ruleSessionProperties,
						RuleRuntime.STATELESS_SESSION_TYPE);

	  }
	  catch (Exception e) {
	  	System.out.println("Exception while creating a Greeting Engine");
	  	if (e instanceof RuntimeException)
			throw (RuntimeException) e;
		else
			throw new RuntimeException(e);
	  }
		/*

		String fileName = "HelloCustomer.xls";  
		String methodName = "helloCustomer";
		// extend fileName
		String extendedFileName = getClass().getClassLoader().getResource(fileName).toExternalForm();
		// define context
		String contextKey = getClass().getClassLoader().getResource(fileName).getPath();
		contextKey = new File(contextKey).getParent().toString();
		System.out.println("Context: " + contextKey);
		IUserContext context = new UserContext(getClass().getClassLoader(), contextKey);
		// create engine
		engine = new XlsRuleEngine(extendedFileName, methodName, context);
		*/
	}

	public String generateGreeting(Customer customer) {
		
	  try {
		System.out.println("Run Engine for Customer: gender=" + customer.gender 
		        + " age=" + customer.age
				+ " Status=" + customer.maritalStatus);
		EngineResponse response = new EngineResponse();
		
		Object[] objects = new Object[] { customer, response }; 
		Object[] args = { customer, response };
		
		statelessRuleSession.executeRules(Arrays.asList(args));
	
		String result = response.getMap().get("greeting") + ", "
				+ response.getMap().get("salutation") + " " + customer.getName()
				+ "!";
		System.out.println("Response: " + result);
		return result;
	  }
	  catch (Exception e) {
	  	System.out.println("Exception in generateGreeting()");
	  	if (e instanceof RuntimeException)
			throw (RuntimeException) e;
		else
			throw new RuntimeException(e);
	  }
	}
	
	public static void main(String[] args)
	{
		GreetingEngine engine = new GreetingEngine();
		Customer customer = new Customer();
		customer.setName("Robinson");
		customer.setGender("Female");
		customer.setMaritalStatus("Married");
		engine.generateGreeting(customer);
	}
}