package hello;


/**
 * A Java test for separate runs of different rule tables
 * 
 * @author jf
 */

import com.openrules.ruleengine.OpenRulesEngine;

public class RunHelloCustomer
{
	public static void main(String[] args)
	{
		Customer customer = new Customer();
		customer.setName("Robinson");
		customer.setGender("Female");
		customer.setMaritalStatus("Married");
		
		Request request = new Request();
		request.setCustomer(customer);
		
		Response response = new Response();
		
		Object[] objects = new Object[] { request, response };
		
		OpenRulesEngine engine = new OpenRulesEngine("file:rules/HelloCustomer.xls");
		
		String methodName = "defineGreeting";
		System.out.println("Run Engine for "+methodName);
		engine.run(methodName,objects);
		
		methodName = "defineSalutation";
		System.out.println("Run Engine for "+methodName);
		engine.run(methodName,objects);
		
		System.out.println("Response: " + 
		 					response.getMap().get("greeting") + ", " +
							response.getMap().get("salutation") + 
							customer.getName() + "!"		 					
		 					);
	}
}
